//Откуда взялось число 999 ? - это указание диапазона,в котором число будет воспринято как данная температура в даипозоне -49.9 до +49.9. Алгоритм взят с сайта homesmart. Спасибо.
//скетч для приемника термометра на 2 передатчика. Выводится наиболее низкая температура из принятой. 
//передатчики передают раз в 21 мин. Если не было успешного приема в течении 30 минут на индикатор выводится E--1 или E--2 для каждого датчика соотв.
#include <RCSwitch.h>
#include <SevenSeg.h>


SevenSeg disp(3, 4, 5, 6, 7, 8, 9);

int speakerPin = 13;
int length = 3;                  // 15 число нот
char notes[] = "cc"; // пробел - пауза
int beats[] = { 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 2, 4 };
int tempo = 300;

unsigned long previousMillis = 0;
unsigned long previousMillis1 = 0;
unsigned long previousMillis2 = 0;
unsigned long period = 1800000; // ( 1800000)30 минут в миллисекундах
//если нет сигнала с датчика >30 мин выводится номер датчика, от которого нет сигнала. 303000 - 1 датчик. 308000 - 2 датчик.

void playTone(int tone, int duration) {
  for (long i = 0; i < duration * 1000L; i += tone * 2) {
    digitalWrite(speakerPin, HIGH);
    delayMicroseconds(tone);
    digitalWrite(speakerPin, LOW);
    delayMicroseconds(tone);
  }
}

void playNote(char note, int duration) {
  char names[] = { 'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C' };
  int tones[] = { 1915, 1700, 1519, 1432, 1275, 1136, 1014, 956 };

  // проиграть тон, соответствующий ноте
  for (int i = 0; i < 8; i++) {
    if (names[i] == note) {
      playTone(tones[i], duration);
    }
  }
}


const int numOfDigits = 4;
//int digitPins[numOfDigits]={11,12,13,A0};
int digitPins[numOfDigits] = {A1, A0, 12, 11};
String s;

RCSwitch mySwitch = RCSwitch();

long humidity1 = 0.0, temperature1 = 0.0, temperature2 = 0.0, resulttemperature = 0.0;

#define key1  300000 // датчик влажность1
#define key2  303000 // датчик температуры1
#define key3  305000 // датчик влажность2
#define key4  308000 // датчик температуры2
//#define DEBUG

#define LCD_UPDATE_TIME  1000
unsigned long lcdLastUpdateTime = 0;

void setup() {
  { disp.setDigitPins(numOfDigits, digitPins);
    disp.setDPPin(10);
    // disp.setTimer(2);
    //  disp.startTimer();
    disp.setActivePinState(LOW, LOW);
    pinMode(speakerPin, OUTPUT);
  }
  {
    mySwitch.enableReceive(0);  // Receiver on inerrupt 0 => that is pin #2 // иницилизация.Используется вывод м/к с прерыванием под номером 0.
    Serial.begin(9600);
    Serial.println("Receiver");
  }
  //музыка
  for (int i = 0; i < length; i++) {
    if (notes[i] == ' ') {
      delay(beats[i] * tempo); // пауза
    } else {
      playNote(notes[i], beats[i] * tempo);
    }

    // пауза между нотами
    delay(tempo / 2);
  }
  //музыка
}

void loop()
{

  if (mySwitch.available()) {


    long receivedCode =  mySwitch.getReceivedValue();
//    if (receivedCode == 0) {
      // обработка:не верный формат данных
//      Serial.println("Error");
//    }
//    else
//    {
//      if (key1 <= receivedCode && key1 + 999 > receivedCode)

//      {
//        humidity1 = (receivedCode - key1) / 10.0;
//      }

 //     else if (key2 <= receivedCode && key2 + 999 > receivedCode)
      {
 //       temperature1 = (receivedCode - key2 - 500.0) / 10.0;
 //       previousMillis1 = millis();
//      }


//      else if (key4 <= receivedCode && key4 + 999 > receivedCode)
//      {
 //       temperature2 = (receivedCode - key4 - 500.0) / 10.0;
 //       previousMillis2 = millis();
//      }
//if (key1<=receivedCode && key1+999>receivedCode) humidity1=(receivedCode-key1)/10.0;      
if (key2<=receivedCode && key2+999>receivedCode){ temperature1=(receivedCode-key2-500.0)/10.0; previousMillis1 = millis();}

else if (key4<=receivedCode && key4+999>receivedCode) {temperature2=(receivedCode-key4-500.0)/10.0; previousMillis2 = millis();}



    }

    // можно не делить на 10,если отправляем через езернет на компьютер- разделить можно там.
    Serial.print("receivedCode:");
    Serial.println(receivedCode);
#ifdef DEBUG

  Serial.print("humidity1:");
  Serial.println(humidity1);
  Serial.print("temperature1:");
  Serial.println(temperature1);

  // Serial.print("humidity2:");
  // Serial.println(humidity2);
  Serial.print("temperature2:");
  Serial.println(temperature2);

  Serial.print("resulttemperature:");
  Serial.println(resulttemperature);

#endif

    mySwitch.resetAvailable(); // сброс данных.
  } // end available
  // тут могут выводится данные tempout и tempin на лсд экран или отправлятся через езернет.

  if (temperature1 <= temperature2)
  {
    resulttemperature = temperature1;
  }
  else

  {
    resulttemperature = temperature2;
  }





  // проверяем передает ли передатчик показания  >30мин,
  if (millis() - previousMillis1 > period)
  { s = "E--1";
  }
  else if (millis() - previousMillis2 > period)
  { s = "E--2";
  }
  else
  { s = String(resulttemperature) + '\370';
  }
 disp.write(s); 
  }


//}

  // delay(100);




//ISR(TIMER2_COMPA_vect) {
//  disp.interruptAction();
//}

